Index: trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_mpi_transfert.F90	(revision 1543)
@@ -9,5 +9,5 @@
                      bcast_mpi_i,bcast_mpi_i1,bcast_mpi_i2,bcast_mpi_i3,bcast_mpi_i4, &
                      bcast_mpi_r,bcast_mpi_r1,bcast_mpi_r2,bcast_mpi_r3,bcast_mpi_r4, &
-		     bcast_mpi_l,bcast_mpi_l1,bcast_mpi_l2,bcast_mpi_l3,bcast_mpi_l4
+                     bcast_mpi_l,bcast_mpi_l1,bcast_mpi_l2,bcast_mpi_l3,bcast_mpi_l4
   END INTERFACE
 
@@ -15,5 +15,5 @@
     MODULE PROCEDURE scatter_mpi_i,scatter_mpi_i1,scatter_mpi_i2,scatter_mpi_i3, &
                      scatter_mpi_r,scatter_mpi_r1,scatter_mpi_r2,scatter_mpi_r3, &
-		     scatter_mpi_l,scatter_mpi_l1,scatter_mpi_l2,scatter_mpi_l3
+                     scatter_mpi_l,scatter_mpi_l1,scatter_mpi_l2,scatter_mpi_l3
   END INTERFACE
 
@@ -22,5 +22,5 @@
     MODULE PROCEDURE gather_mpi_i,gather_mpi_i1,gather_mpi_i2,gather_mpi_i3, &
                      gather_mpi_r,gather_mpi_r1,gather_mpi_r2,gather_mpi_r3, &
-		     gather_mpi_l,gather_mpi_l1,gather_mpi_l2,gather_mpi_l3  
+                     gather_mpi_l,gather_mpi_l1,gather_mpi_l2,gather_mpi_l3  
   END INTERFACE
   
@@ -28,5 +28,5 @@
     MODULE PROCEDURE scatter2D_mpi_i,scatter2D_mpi_i1,scatter2D_mpi_i2,scatter2D_mpi_i3, &
                      scatter2D_mpi_r,scatter2D_mpi_r1,scatter2D_mpi_r2,scatter2D_mpi_r3, &
-		     scatter2D_mpi_l,scatter2D_mpi_l1,scatter2D_mpi_l2,scatter2D_mpi_l3
+                     scatter2D_mpi_l,scatter2D_mpi_l1,scatter2D_mpi_l2,scatter2D_mpi_l3
   END INTERFACE
 
@@ -34,5 +34,5 @@
     MODULE PROCEDURE gather2D_mpi_i,gather2D_mpi_i1,gather2D_mpi_i2,gather2D_mpi_i3, &
                      gather2D_mpi_r,gather2D_mpi_r1,gather2D_mpi_r2,gather2D_mpi_r3, &
-		     gather2D_mpi_l,gather2D_mpi_l1,gather2D_mpi_l2,gather2D_mpi_l3
+                     gather2D_mpi_l,gather2D_mpi_l1,gather2D_mpi_l2,gather2D_mpi_l3
   END INTERFACE 
   
@@ -45,5 +45,5 @@
     MODULE PROCEDURE grid1dTo2d_mpi_i,grid1dTo2d_mpi_i1,grid1dTo2d_mpi_i2,grid1dTo2d_mpi_i3, &
                      grid1dTo2d_mpi_r,grid1dTo2d_mpi_r1,grid1dTo2d_mpi_r2,grid1dTo2d_mpi_r3, &
-		     grid1dTo2d_mpi_l,grid1dTo2d_mpi_l1,grid1dTo2d_mpi_l2,grid1dTo2d_mpi_l3
+                     grid1dTo2d_mpi_l,grid1dTo2d_mpi_l1,grid1dTo2d_mpi_l2,grid1dTo2d_mpi_l3
  END INTERFACE 
 
@@ -51,5 +51,5 @@
     MODULE PROCEDURE grid2dTo1d_mpi_i,grid2dTo1d_mpi_i1,grid2dTo1d_mpi_i2,grid2dTo1d_mpi_i3, &
                      grid2dTo1d_mpi_r,grid2dTo1d_mpi_r1,grid2dTo1d_mpi_r2,grid2dTo1d_mpi_r3, &
-		     grid2dTo1d_mpi_l,grid2dTo1d_mpi_l1,grid2dTo1d_mpi_l2,grid2dTo1d_mpi_l3
+                     grid2dTo1d_mpi_l,grid2dTo1d_mpi_l1,grid2dTo1d_mpi_l2,grid2dTo1d_mpi_l3
  END INTERFACE 
     
@@ -514,5 +514,5 @@
 
   SUBROUTINE scatter2D_mpi_i(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -528,5 +528,5 @@
 
   SUBROUTINE scatter2D_mpi_i1(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -541,5 +541,5 @@
 
   SUBROUTINE scatter2D_mpi_i2(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -555,5 +555,5 @@
   
   SUBROUTINE scatter2D_mpi_i3(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -570,5 +570,5 @@
 
   SUBROUTINE scatter2D_mpi_r(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -585,5 +585,5 @@
 
   SUBROUTINE scatter2D_mpi_r1(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
     REAL,INTENT(IN),DIMENSION(:,:,:) :: VarIn
@@ -599,5 +599,5 @@
 
   SUBROUTINE scatter2D_mpi_r2(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -613,5 +613,5 @@
   
   SUBROUTINE scatter2D_mpi_r3(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -628,5 +628,5 @@
   
   SUBROUTINE scatter2D_mpi_l(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -643,5 +643,5 @@
 
   SUBROUTINE scatter2D_mpi_l1(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -658,5 +658,5 @@
 
   SUBROUTINE scatter2D_mpi_l2(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -672,5 +672,5 @@
   
   SUBROUTINE scatter2D_mpi_l3(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid2dTo1d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -691,5 +691,5 @@
 
   SUBROUTINE gather2D_mpi_i(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -705,5 +705,5 @@
 
   SUBROUTINE gather2D_mpi_i1(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -719,5 +719,5 @@
 
   SUBROUTINE gather2D_mpi_i2(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -733,5 +733,5 @@
   
   SUBROUTINE gather2D_mpi_i3(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -749,5 +749,5 @@
 
   SUBROUTINE gather2D_mpi_r(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -763,5 +763,5 @@
 
   SUBROUTINE gather2D_mpi_r1(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -777,5 +777,5 @@
 
   SUBROUTINE gather2D_mpi_r2(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -791,5 +791,5 @@
   
   SUBROUTINE gather2D_mpi_r3(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -807,5 +807,5 @@
   
   SUBROUTINE gather2D_mpi_l(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -821,5 +821,5 @@
 
   SUBROUTINE gather2D_mpi_l1(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -835,5 +835,5 @@
 
   SUBROUTINE gather2D_mpi_l2(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -849,5 +849,5 @@
   
   SUBROUTINE gather2D_mpi_l3(VarIn, VarOut)
-    USE mod_grid_phy_lmdz, only: klon_glo, grid1dTo2d_glo
+    USE mod_grid_phy_lmdz
     IMPLICIT NONE
   
@@ -1236,5 +1236,5 @@
 
   SUBROUTINE bcast_mpi_cgen(var,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     IMPLICIT NONE
     
@@ -1250,5 +1250,5 @@
     
 #ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_CHARACTER,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_BCAST(Var,nb,MPI_CHARACTER,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
         
@@ -1258,9 +1258,9 @@
       
   SUBROUTINE bcast_mpi_igen(var,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
-    IMPLICIT NONE
-    
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    
+    INTEGER,INTENT(IN) :: nb
     INTEGER,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
     
 #ifdef CPP_MPI
@@ -1272,5 +1272,5 @@
 
 #ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_INTEGER,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_BCAST(Var,nb,MPI_INTEGER,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
         
@@ -1281,9 +1281,32 @@
   
   SUBROUTINE bcast_mpi_rgen(var,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
-    IMPLICIT NONE
-    
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    
+    INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(INOUT) :: Var
+    
+#ifdef CPP_MPI
+    INCLUDE 'mpif.h'
+#endif
+    INTEGER :: ierr
+
+    IF (.not.is_using_mpi) RETURN
+
+#ifdef CPP_MPI
+    CALL MPI_BCAST(Var,nb,MPI_REAL_LMDZ,mpi_master,COMM_LMDZ_PHY,ierr)
+#endif
+    
+  END SUBROUTINE bcast_mpi_rgen
+  
+
+
+
+  SUBROUTINE bcast_mpi_lgen(var,nb)
+    USE mod_phys_lmdz_mpi_data
+    IMPLICIT NONE
+    
     INTEGER,INTENT(IN) :: nb
+    LOGICAL,DIMENSION(nb),INTENT(INOUT) :: Var
     
 #ifdef CPP_MPI
@@ -1295,32 +1318,5 @@
 
 #ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_REAL_LMDZ,mpi_root_x,COMM_LMDZ_PHY,ierr)
-#endif
-    
-  END SUBROUTINE bcast_mpi_rgen
-  
-
-
-
-  SUBROUTINE bcast_mpi_lgen(var,nb)
-    USE mod_phys_lmdz_mpi_data ,  mpi_root_x=>mpi_root
-    IMPLICIT NONE
-    
-    LOGICAL,DIMENSION(nb),INTENT(INOUT) :: Var
-    INTEGER,INTENT(IN) :: nb
-    
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
-    INTEGER :: ierr
-
-    IF (.not.is_using_mpi) RETURN
-
-#ifdef CPP_MPI
-    CALL MPI_BCAST(Var,nb,MPI_LOGICAL,mpi_root_x,COMM_LMDZ_PHY,ierr)
-    if (ierr.ne.MPI_SUCCESS) then
-      write(*,*) "bcast_mpi error: ierr=",ierr
-      stop
-    endif
+    CALL MPI_BCAST(Var,nb,MPI_LOGICAL,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
 
@@ -1330,5 +1326,5 @@
 
   SUBROUTINE scatter_mpi_igen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1369,5 +1365,5 @@
 #ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_INTEGER,VarOut,klon_mpi*dimsize,   &
-                      MPI_INTEGER,mpi_root_x, COMM_LMDZ_PHY,ierr)
+                      MPI_INTEGER,mpi_master, COMM_LMDZ_PHY,ierr)
 #endif
 
@@ -1375,5 +1371,5 @@
 
   SUBROUTINE scatter_mpi_rgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1413,5 +1409,5 @@
 #ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_REAL_LMDZ,VarOut,klon_mpi*dimsize,   &
-                      MPI_REAL_LMDZ,mpi_root_x, COMM_LMDZ_PHY,ierr)
+                      MPI_REAL_LMDZ,mpi_master, COMM_LMDZ_PHY,ierr)
 
 #endif
@@ -1421,5 +1417,5 @@
   
   SUBROUTINE scatter_mpi_lgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1459,5 +1455,5 @@
 #ifdef CPP_MPI
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_LOGICAL,VarOut,klon_mpi*dimsize,   &
-                      MPI_LOGICAL,mpi_root_x, COMM_LMDZ_PHY,ierr)
+                      MPI_LOGICAL,mpi_master, COMM_LMDZ_PHY,ierr)
 #endif
 
@@ -1468,5 +1464,5 @@
 
   SUBROUTINE gather_mpi_igen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1497,5 +1493,5 @@
         displs(rank)=Index-1
         counts(rank)=nb*dimsize
-	Index=Index+nb*dimsize
+        Index=Index+nb*dimsize
       ENDDO
      
@@ -1504,8 +1500,8 @@
 #ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_INTEGER,VarTmp,counts,displs,   &
-                     MPI_INTEGER,mpi_root_x, COMM_LMDZ_PHY,ierr)
-#endif
-
-		          
+                     MPI_INTEGER,mpi_master, COMM_LMDZ_PHY,ierr)
+#endif
+
+                          
     IF (is_mpi_root) THEN
       Index=1
@@ -1514,5 +1510,5 @@
         DO i=1,dimsize
           VarOut(klon_mpi_para_begin(rank):klon_mpi_para_end(rank),i)=VarTmp(Index:Index+nb-1)
-	  Index=Index+nb
+          Index=Index+nb
         ENDDO
       ENDDO
@@ -1522,5 +1518,5 @@
 
   SUBROUTINE gather_mpi_rgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1546,5 +1542,5 @@
         displs(rank)=Index-1
         counts(rank)=nb*dimsize
-	Index=Index+nb*dimsize
+        Index=Index+nb*dimsize
       ENDDO
     ENDIF
@@ -1557,7 +1553,7 @@
 #ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_REAL_LMDZ,VarTmp,counts,displs,   &
-                      MPI_REAL_LMDZ,mpi_root_x, COMM_LMDZ_PHY,ierr)
-#endif
-		          
+                      MPI_REAL_LMDZ,mpi_master, COMM_LMDZ_PHY,ierr)
+#endif
+                          
     IF (is_mpi_root) THEN
       Index=1
@@ -1566,5 +1562,5 @@
         DO i=1,dimsize
           VarOut(klon_mpi_para_begin(rank):klon_mpi_para_end(rank),i)=VarTmp(Index:Index+nb-1)
-	  Index=Index+nb
+          Index=Index+nb
         ENDDO
       ENDDO
@@ -1574,5 +1570,5 @@
 
   SUBROUTINE gather_mpi_lgen(VarIn, VarOut, dimsize)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1603,5 +1599,5 @@
         displs(rank)=Index-1
         counts(rank)=nb*dimsize
-	Index=Index+nb*dimsize
+        Index=Index+nb*dimsize
       ENDDO
     ENDIF
@@ -1610,7 +1606,7 @@
 #ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_LOGICAL,VarTmp,counts,displs,   &
-                      MPI_LOGICAL,mpi_root_x, COMM_LMDZ_PHY,ierr)
-#endif
-		          
+                      MPI_LOGICAL,mpi_master, COMM_LMDZ_PHY,ierr)
+#endif
+                          
     IF (is_mpi_root) THEN
       Index=1
@@ -1619,5 +1615,5 @@
         DO i=1,dimsize
           VarOut(klon_mpi_para_begin(rank):klon_mpi_para_end(rank),i)=VarTmp(Index:Index+nb-1)
-	  Index=Index+nb
+          Index=Index+nb
         ENDDO
       ENDDO
@@ -1629,5 +1625,5 @@
 
   SUBROUTINE reduce_sum_mpi_igen(VarIn,VarOut,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
     IMPLICIT NONE
@@ -1637,7 +1633,7 @@
 #endif
    
+    INTEGER,INTENT(IN) :: nb
     INTEGER,DIMENSION(nb),INTENT(IN) :: VarIn
     INTEGER,DIMENSION(nb),INTENT(OUT) :: VarOut    
-    INTEGER,INTENT(IN) :: nb
     INTEGER :: ierr
    
@@ -1649,5 +1645,5 @@
 
 #ifdef CPP_MPI
-    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_SUM,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_SUM,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
             
@@ -1655,5 +1651,5 @@
   
   SUBROUTINE reduce_sum_mpi_rgen(VarIn,VarOut,nb)
-    USE mod_phys_lmdz_mpi_data , mpi_root_x=>mpi_root
+    USE mod_phys_lmdz_mpi_data 
     USE mod_grid_phy_lmdz
 
@@ -1664,7 +1660,7 @@
 #endif
     
+    INTEGER,INTENT(IN) :: nb
     REAL,DIMENSION(nb),INTENT(IN) :: VarIn
     REAL,DIMENSION(nb),INTENT(OUT) :: VarOut    
-    INTEGER,INTENT(IN) :: nb
     INTEGER :: ierr
  
@@ -1675,5 +1671,5 @@
    
 #ifdef CPP_MPI
-    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_SUM,mpi_root_x,COMM_LMDZ_PHY,ierr)
+    CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_SUM,mpi_master,COMM_LMDZ_PHY,ierr)
 #endif
         
@@ -1711,5 +1707,5 @@
         DO ij=1,nbp_lon
          VarOut(ij,i)=VarIn(1,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1719,5 +1715,5 @@
         DO ij=nbp_lon*(jj_nb-1)+1,nbp_lon*jj_nb
          VarOut(ij,i)=VarIn(klon_mpi,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1755,5 +1751,5 @@
         DO ij=1,nbp_lon
          VarOut(ij,i)=VarIn(1,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1763,5 +1759,5 @@
         DO ij=nbp_lon*(jj_nb-1)+1,nbp_lon*jj_nb
          VarOut(ij,i)=VarIn(klon_mpi,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1800,5 +1796,5 @@
         DO ij=1,nbp_lon
          VarOut(ij,i)=VarIn(1,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1808,5 +1804,5 @@
         DO ij=nbp_lon*(jj_nb-1)+1,nbp_lon*jj_nb
          VarOut(ij,i)=VarIn(klon_mpi,i)
-	ENDDO
+        ENDDO
       ENDDO
     ENDIF
@@ -1905,2 +1901,3 @@
 
 END MODULE mod_phys_lmdz_mpi_transfert
+
Index: trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_omp_data.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_omp_data.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_omp_data.F90	(revision 1543)
@@ -1,4 +1,4 @@
 !
-!$Id: mod_phys_lmdz_omp_data.F90 1575 2011-09-21 13:57:48Z jghattas $
+!$Id: mod_phys_lmdz_omp_data.F90 2326 2015-07-10 12:24:29Z emillour $
 !
 MODULE mod_phys_lmdz_omp_data
@@ -91,17 +91,17 @@
   SUBROUTINE Print_module_data
   IMPLICIT NONE
-!  INCLUDE "iniprint.h"
+  INCLUDE "iniprint.h"
 
 !$OMP CRITICAL  
-  WRITE(*,*)'--------> TASK ',omp_rank
-  WRITE(*,*)'omp_size =',omp_size
-  WRITE(*,*)'omp_rank =',omp_rank
-  WRITE(*,*)'is_omp_root =',is_omp_root
-  WRITE(*,*)'klon_omp_para_nb =',klon_omp_para_nb
-  WRITE(*,*)'klon_omp_para_begin =',klon_omp_para_begin
-  WRITE(*,*)'klon_omp_para_end =',klon_omp_para_end    
-  WRITE(*,*)'klon_omp =',klon_omp
-  WRITE(*,*)'klon_omp_begin =',klon_omp_begin
-  WRITE(*,*)'klon_omp_end =',klon_omp_end    
+  WRITE(lunout,*)'--------> TASK ',omp_rank
+  WRITE(lunout,*)'omp_size =',omp_size
+  WRITE(lunout,*)'omp_rank =',omp_rank
+  WRITE(lunout,*)'is_omp_root =',is_omp_root
+  WRITE(lunout,*)'klon_omp_para_nb =',klon_omp_para_nb
+  WRITE(lunout,*)'klon_omp_para_begin =',klon_omp_para_begin
+  WRITE(lunout,*)'klon_omp_para_end =',klon_omp_para_end    
+  WRITE(lunout,*)'klon_omp =',klon_omp
+  WRITE(lunout,*)'klon_omp_begin =',klon_omp_begin
+  WRITE(lunout,*)'klon_omp_end =',klon_omp_end    
 !$OMP END CRITICAL
 
Index: trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_omp_transfert.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_omp_transfert.F90	(revision 1543)
@@ -25,5 +25,5 @@
                      bcast_omp_i,bcast_omp_i1,bcast_omp_i2,bcast_omp_i3,bcast_omp_i4, &
                      bcast_omp_r,bcast_omp_r1,bcast_omp_r2,bcast_omp_r3,bcast_omp_r4, &
-		     bcast_omp_l,bcast_omp_l1,bcast_omp_l2,bcast_omp_l3,bcast_omp_l4
+                     bcast_omp_l,bcast_omp_l1,bcast_omp_l2,bcast_omp_l3,bcast_omp_l4
   END INTERFACE
 
@@ -31,5 +31,5 @@
     MODULE PROCEDURE scatter_omp_i,scatter_omp_i1,scatter_omp_i2,scatter_omp_i3, &
                      scatter_omp_r,scatter_omp_r1,scatter_omp_r2,scatter_omp_r3, &
-		     scatter_omp_l,scatter_omp_l1,scatter_omp_l2,scatter_omp_l3
+                     scatter_omp_l,scatter_omp_l1,scatter_omp_l2,scatter_omp_l3
   END INTERFACE
 
@@ -38,5 +38,5 @@
     MODULE PROCEDURE gather_omp_i,gather_omp_i1,gather_omp_i2,gather_omp_i3, &
                      gather_omp_r,gather_omp_r1,gather_omp_r2,gather_omp_r3, &
-		     gather_omp_l,gather_omp_l1,gather_omp_l2,gather_omp_l3  
+                     gather_omp_l,gather_omp_l1,gather_omp_l2,gather_omp_l3  
   END INTERFACE
   
@@ -48,8 +48,15 @@
 
 
-  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp
+  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp, omp_barrier
 
 CONTAINS
 
+  SUBROUTINE omp_barrier
+  IMPLICIT NONE
+
+!$OMP BARRIER
+
+  END SUBROUTINE omp_barrier
+  
   SUBROUTINE check_buffer_i(buff_size)
   IMPLICIT NONE
@@ -733,7 +740,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Var
     INTEGER,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -757,7 +764,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     REAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
 
     INTEGER :: i
@@ -780,7 +787,7 @@
   IMPLICIT NONE
     
+    INTEGER,INTENT(IN) :: Nb
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Var
     LOGICAL,DIMENSION(Nb),INTENT(INOUT) :: Buff
-    INTEGER,INTENT(IN) :: Nb
   
     INTEGER :: i
@@ -802,5 +809,5 @@
 
   SUBROUTINE scatter_omp_igen(VarIn,VarOut,dimsize,Buff)
-    USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+    USE mod_phys_lmdz_omp_data
     USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
     IMPLICIT NONE
@@ -833,5 +840,5 @@
 
   SUBROUTINE scatter_omp_rgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -864,5 +871,5 @@
 
   SUBROUTINE scatter_omp_lgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -898,5 +905,5 @@
 
   SUBROUTINE gather_omp_igen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -930,5 +937,5 @@
 
   SUBROUTINE gather_omp_rgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
@@ -962,5 +969,5 @@
 
   SUBROUTINE gather_omp_lgen(VarIn,VarOut,dimsize,Buff)
-  USE mod_phys_lmdz_omp_data, only: klon_omp, klon_omp_begin
+  USE mod_phys_lmdz_omp_data
   USE mod_phys_lmdz_mpi_data, ONLY : klon_mpi 
   IMPLICIT NONE
Index: trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_para.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_para.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phy_common/mod_phys_lmdz_para.F90	(revision 1543)
@@ -16,12 +16,12 @@
 CONTAINS
 
-  SUBROUTINE Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+  SUBROUTINE Init_phys_lmdz_para(nbp,nbp_lon,nbp_lat,communicator)
   IMPLICIT NONE
-    INTEGER,INTENT(in) :: iim
-    INTEGER,INTENT(in) :: jjp1
-    INTEGER,INTENT(in) :: nb_proc
-    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+    INTEGER,INTENT(in) :: nbp
+    INTEGER,INTENT(in) :: nbp_lon
+    INTEGER,INTENT(in) :: nbp_lat
+    INTEGER,INTENT(in) :: communicator
 
-    CALL Init_phys_lmdz_mpi_data(iim,jjp1,nb_proc,distrib)
+    CALL Init_phys_lmdz_mpi_data(nbp,nbp_lon,nbp_lat,communicator)
 !$OMP PARALLEL
     CALL Init_phys_lmdz_omp_data(klon_mpi)
@@ -45,8 +45,7 @@
 
   SUBROUTINE Test_transfert
-  USE mod_grid_phy_lmdz, only: klon_glo, nbp_lev, nbp_lon, nbp_lat, &
-                               grid1dTo2d_glo, grid2dTo1d_glo
+  USE mod_grid_phy_lmdz
   IMPLICIT NONE
-!    INCLUDE "iniprint.h"
+    INCLUDE "iniprint.h"
  
     REAL :: Test_Field1d_glo(klon_glo,nbp_lev)
@@ -82,5 +81,5 @@
 !$OMP MASTER  
       Checksum=sum(Test_Field1d_glo-tmp1d_glo)
-      WRITE(*,*) "------> Checksum =",Checksum," MUST BE 0"
+      WRITE(lunout,*) "------> Checksum =",Checksum," MUST BE 0"
 !$OMP END MASTER
     ENDIF
@@ -94,5 +93,5 @@
 !$OMP MASTER  
       Checksum=sum(Test_Field1d_glo-tmp1d_glo)
-      WRITE(*,*) "------> Checksum =",Checksum," MUST BE 0"
+      WRITE(lunout,*) "------> Checksum =",Checksum," MUST BE 0"
 !$OMP END MASTER
     ENDIF
@@ -104,5 +103,5 @@
 !$OMP MASTER  
       Checksum=sum(Test_Field1d_glo*omp_size*mpi_size-tmp1d_glo)
-      WRITE(*,*) "------> Checksum =",Checksum," MUST BE 0"
+      WRITE(lunout,*) "------> Checksum =",Checksum," MUST BE 0"
 !$OMP END MASTER
     ENDIF
Index: trunk/LMDZ.MARS/libf/phy_common/physics_distribution_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phy_common/physics_distribution_mod.F90	(revision 1543)
+++ trunk/LMDZ.MARS/libf/phy_common/physics_distribution_mod.F90	(revision 1543)
@@ -0,0 +1,71 @@
+!
+!$Id: physics_distribution_mod.F90 2351 2015-08-25 15:14:59Z emillour $
+!
+MODULE physics_distribution_mod
+
+
+CONTAINS
+
+  SUBROUTINE init_physics_distribution(grid_type, nvertex, &
+                                       nbp, nbp_lon, nbp_lat, nbp_lev, &
+                                       communicator)
+  USE mod_phys_lmdz_para, ONLY: init_phys_lmdz_para
+  USE mod_grid_phy_lmdz, ONLY: init_grid_phy_lmdz
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: grid_type 
+    INTEGER,INTENT(IN) :: nvertex 
+    INTEGER,INTENT(IN) :: nbp           
+    INTEGER,INTENT(IN) :: nbp_lon
+    INTEGER,INTENT(IN) :: nbp_lat
+    INTEGER,INTENT(IN) :: nbp_lev
+    INTEGER,INTENT(IN) :: communicator
+
+
+    CALL init_grid_phy_lmdz(grid_type,nvertex, nbp_lon,nbp_lat,nbp_lev)
+    CALL init_phys_lmdz_para(nbp,nbp_lon, nbp_lat, communicator)
+
+  END SUBROUTINE init_physics_distribution  
+
+!SUBROUTINE Init_Phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
+!  USE mod_phys_lmdz_para, ONLY: Init_phys_lmdz_para!, klon_omp
+!  USE mod_grid_phy_lmdz, ONLY: Init_grid_phy_lmdz!, nbp_lev
+!  USE dimphy, ONLY : Init_dimphy
+!  USE infotrac_phy, ONLY : type_trac
+!#ifdef REPROBUS
+!  USE CHEM_REP, ONLY : Init_chem_rep_phys
+!#endif
+
+!  IMPLICIT NONE
+  
+!    INTEGER,INTENT(in) :: iim
+!    INTEGER,INTENT(in) :: jjp1
+!    INTEGER,INTENT(in) :: llm
+!    INTEGER,INTENT(in) :: nb_proc
+!    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+
+
+!    CALL Init_grid_phy_lmdz(iim,jjp1,llm)
+!    CALL Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+!!$OMP PARALLEL
+!    CALL Init_dimphy(klon_omp,nbp_lev)
+!
+!! Initialization of Reprobus
+!    IF (type_trac == 'repr') THEN
+!#ifdef REPROBUS
+!       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+!#endif
+!    END IF
+!
+!!$OMP END PARALLEL
+ 
+!END SUBROUTINE Init_Phys_lmdz  
+
+
+
+
+
+
+
+
+END MODULE physics_distribution_mod
+
Index: trunk/LMDZ.MARS/libf/phymars/aeropacity.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/aeropacity.F	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phymars/aeropacity.F	(revision 1543)
@@ -8,8 +8,8 @@
      &                      igcm_dust_submicron, rho_dust, rho_ice,
      &                      nqdust
-      use comgeomphy, only: latitude ! grid point latitudes (rad)
+      use geometry_mod, only: latitude ! grid point latitudes (rad)
       use comgeomfi_h, only: sinlat ! sines of grid point latitudes
 #ifdef DUSTSTORM
-      use comgeomphy, only: longitude
+      use geometry_mod, only: longitude
       use tracer_mod, only: r3n_q, ref_r0, igcm_dust_number
 #endif
Index: trunk/LMDZ.MARS/libf/phymars/albedocaps.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/albedocaps.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phymars/albedocaps.F90	(revision 1543)
@@ -6,5 +6,5 @@
 ! to use the 'getin' routine 
 use ioipsl_getincom, only: getin
-use comgeomphy, only: latitude ! grid point latitudes (rad)
+use geometry_mod, only: latitude ! grid point latitudes (rad)
 use surfdat_h, only: TESicealbedo, TESice_Ncoef, TESice_Scoef, &
                      emisice, albedice, watercaptag, albedo_h2o_ice, &
@@ -87,5 +87,5 @@
 subroutine TES_icecap_albedo(zls,ig,alb,icap)
 
-use comgeomphy, only: latitude, longitude ! in radians
+use geometry_mod, only: latitude, longitude ! in radians
 use surfdat_h, only: albedice, TESice_Ncoef, TESice_Scoef
 use netcdf, only: nf90_open, NF90_NOWRITE, NF90_NOERR, &
Index: trunk/LMDZ.MARS/libf/phymars/co2snow.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/co2snow.F	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phymars/co2snow.F	(revision 1543)
@@ -3,5 +3,5 @@
 
       use surfdat_h, only: iceradius, dtemisice
-      use comgeomphy, only: latitude ! grid point latitudes (rad)
+      use geometry_mod, only: latitude ! grid point latitudes (rad)
       use time_phylmdz_mod, only: daysec
       IMPLICIT NONE
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/mod_interface_dyn_phys.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/mod_interface_dyn_phys.F90	(revision 1543)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/mod_interface_dyn_phys.F90	(revision 1543)
@@ -0,0 +1,1 @@
+link ../../dynphy_lonlat/mod_interface_dyn_phys.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F	(revision 1543)
@@ -3,4 +3,6 @@
 ! to use  'getin'
       USE ioipsl_getincom, only: getin
+      use dimphy, only : init_dimphy
+      use mod_grid_phy_lmdz, only : regular_lonlat
       use infotrac, only: nqtot, tname
       use comsoil_h, only: volcapa, layer, mlayer, inertiedat, nsoilmx
@@ -12,5 +14,5 @@
       use slope_mod, only: theta_sl, psi_sl
       use phyredem, only: physdem0,physdem1
-      use comgeomphy, only: initcomgeomphy, cell_area
+      use geometry_mod, only: init_geometry
       use planete_h, only: year_day, periheli, aphelie, peri_day,
      &                     obliquit, emin_turb, lmixmin
@@ -21,5 +23,7 @@
       USE comvert_mod, ONLY: ap,bp,aps,bps,pa,preff,sig
       USE logic_mod, ONLY: hybrid
+      use physics_distribution_mod, only: init_physics_distribution
       use regular_lonlat_mod, only: init_regular_lonlat
+      use mod_interface_dyn_phys, only: init_interface_dyn_phys
       USE phys_state_var_init_mod, ONLY: phys_state_var_init
       IMPLICIT NONE
@@ -106,5 +110,5 @@
       Logical  tracerdyn
       integer :: nq=1 ! number of tracers
-      real :: latitude(1), longitude(1)
+      real :: latitude(1), longitude(1), cell_area(1)
 
       character*2 str2
@@ -119,6 +123,6 @@
 ! initialize "serial/parallel" related stuff
 !      CALL init_phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
-      CALL init_phys_lmdz(1,1,llm,1,(/1/))
-      call initcomgeomphy
+!      CALL init_phys_lmdz(1,1,llm,1,(/1/))
+!      call initcomgeomphy
 
 c ------------------------------------------------------
@@ -483,6 +487,13 @@
 !Mars possible matter with dtphys in input and include!!!
 ! Initializations below should mimick what is done in iniphysiq for 3D GCM
+      call init_physics_distribution(regular_lonlat,4,
+     &                               1,1,1,nlayer,1)
+      call init_interface_dyn_phys
       call init_regular_lonlat(1,1,longitude,latitude,
      &                   (/0.,0./),(/0.,0./))
+      call init_geometry(1,longitude,latitude,
+     &                   (/0.,0.,0.,0./),(/0.,0.,0.,0./),
+     &                   cell_area)
+      call init_dimphy(1,nlayer) ! Initialize dimphy module
       call phys_state_var_init(1,llm,nq,
      .          day0,time,daysec,dtphys,rad,g,r,cpp)
Index: trunk/LMDZ.MARS/libf/phymars/eofdump_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/eofdump_mod.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phymars/eofdump_mod.F90	(revision 1543)
@@ -80,5 +80,5 @@
       subroutine ineofdump(ngrid,nlayer)
 
-      use comgeomphy, only: longitude, latitude
+      use geometry_mod, only: longitude, latitude
       use comcstfi_h, only: pi
       use time_phylmdz_mod, only: daysec, dtphys
Index: trunk/LMDZ.MARS/libf/phymars/getslopes.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/getslopes.F90	(revision 1542)
+++ trunk/LMDZ.MARS/libf/phymars/getslopes.F90	(revision 1543)
@@ -1,5 +1,5 @@
 subroutine getslopes(ngrid,geopot)
     
-use comgeomphy, only: longitude, latitude ! in radians
+use geometry_mod, only: longitude, latitude ! in radians
 use slope_mod, only: theta_sl, psi_sl
 use comcstfi_h, only: g, rad, pi
